#!/usr/bin/perl
 
   use strict;
   use warnings;
   use Cwd 'abs_path';
   use POSIX;
 
   # (c)2019 Comweb NL All RIGHTS RESERVED
   # RJHMM van den Bergh sales2@comweb.nl
   # use at own risk, no liability

  # usage cd to/Your/HTML/root/direcory/on/your/win32/system
  # perl makeXML.pl > myXMLmap.xml
  
  # EDIT THIS ONE IF NEEDED
  my $prefix="https://www.comweb.nl";

  print <<HEADER;
  
  <urlset
      xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
      xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 
         http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">
           
  <!-- Created by Perl script provided by Comweb Netherlands -->
  <!-- (c)Comweb.nl RJHM van den Bergh -->
  <!-- Free for non commercial use -->
            
HEADER
  
  my $startlocationDirectory=abs_path(".");
  my $level=0; # directory level  
 
  getdir($startlocationDirectory); 
  
  sub getdir
  {
      my $dir = shift;
      my $path="";
      opendir (my $dh, $dir) || die "Cannot opend $dir $!";
 
      while( my $file = readdir($dh)) 
      { 
          next if ($file =~ m[^\.{1,2}$]);   # Ignore . and ..
          if (-d $file)  # is directory?
          {
              # directory found add a comment in the sitemap for readability
              print "<!-- DIR $prefix/$file -->\n";
              
              # go one directory level up
              $path = $dir .'/'. $file;  # no $file here is a directory name
              chdir($path); $level++;    # change working directory 
              $path=getcwd();            # get working directory
              $path =~ s/\\/\//g ;       # change \ (w32) to / (Internet url)

              getdir($path);             # recursive call of this function
            
              # getting out of the directory 
              # so go level down
              chdir("..");  $level--;    # change working directory
              $path=getcwd();            # get working directory  
              $path =~ s/\\/\//g ;       # change \ (w32) to / (Internet url)   
        
          } elsif (-f $file)   #no directory perhaps is a file?
          {
              # it is not a directory but a file
              # only look for certain types of extensions           
              if ($file =~ m\(htmL|htm|txt|shtml|zip|java|php|jpg|png|jpeg|gif|avi|pdf|mpg|mpeg)$\i)  
              {
                  # print the <url>   (mandantory)
                  print "<url>\n";

                  # calculate Internet location url
                  my $filepath=getcwd();     # get working directory
                  $filepath =~ s/\\/\//g ;   # change \ (w32) to / (Internet url)
                  # need to replace first part of path\.... with htt//...... ($prefix)
                  my $location = $filepath;
                  $location =~ s/$startlocationDirectory/$prefix/g;
                  $location .="/$file";      # not forget to append the filename

                  # some characters are not allowed in urls like & < > and whitespace
                  my $replace="&amp;";
                  $location =~ s/\&/$replace/g ;  #subtitute & with & 
                  $replace="%20";
                  $location =~ s/ /$replace/g ;       #substute whitespace with %20        

                  # print the <loc>htt//....myurl</loc>   (mandantory)
                  print "  <loc>$location</loc>\n";

                  # calculate a priority 
                  my $priority=ceil((1*0.9**$level)*100)/100;
                  # print the <priority>x.x</priority> tag 
                  print "  <priority>$priority</priority>\n";
                
                  # close the <url> tag 
                  print "</url>\n";
              } 
         }        
     }
     closedir ($dh) || die "Failed to close directo $!";
 }

 # print footer with closing </urlset>
 print <<FOOTER;
 
 </urlset>
 
 <!-- Created by Perl script provided by Comweb Netherlands -->
 <!-- (c)2019 Comweb.nl RJHM van den Bergh -->
 <!-- Free for non commercial use -->
 <!-- use at own risk, beta version -->
          
FOOTER